C   ###################################################################
C   ## E x e r c i s e  O n e: model answer                          ##
C   ################################################################### 

        SUBROUTINE broadcast_ints(frompid,src,dst,nelem)
	  INCLUDE 'fbsp.h'
          INTEGER frompid,src(*),dst(*),nelem
          INTEGER i
        
          CALL bsppushreg(src,nelem*BSPINT)
          CALL bspsync()
          
          CALL bspget(frompid,src,0,dst,nelem*BSPINT)
          CALL bspsync()
          CALL bsppopreg(src)
        END


C   ###################################################################
C   ## The main procedure starts as many processes as possible, and  ##
C   ## then performs a broadcast of an array containing the PID      ##
C   ###################################################################

	PROGRAM MAIN
	INCLUDE 'fbsp.h'
        INTEGER N
	PARAMETER (N=3)
        INTEGER vals(N)
        
        CALL bspbegin(bspnprocs())

          DO i = 0,bspnprocs()
            vals(i)=bsppid()
          END DO
          CALL broadcast_ints(bspnprocs()-1,vals,vals,N)

          DO i = 0,bspnprocs()
            IF (bsppid() .EQ. i) THEN
              WRITE (*,*) 'On process ',i , ' vals = ',
     +                    (vals(j),j=1,N)
            END IF
            CALL bspsync()
          END DO

	CALL bspend()
	END
